<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [bullmq](./bullmq.md) &gt; [QueueScheduler](./bullmq.queuescheduler.md)

## QueueScheduler class

This class is just used for some automatic bookkeeping of the queue, such as updating the delay set as well as moving stalled jobs back to the waiting list.

Jobs are checked for stallness once every "visibility window" seconds. Jobs are then marked as candidates for being stalled, in the next check, the candidates are marked as stalled and moved to wait. Workers need to clean the candidate list with the jobs that they are working on, failing to update the list results in the job ending being stalled.

This class requires a dedicated redis connection, and at least one is needed to be running at a given time, otherwise delays, stalled jobs, retries, repeatable jobs, etc, will not work correctly or at all.

<b>Signature:</b>

```typescript
export declare class QueueScheduler extends QueueBase 
```
<b>Extends:</b> [QueueBase](./bullmq.queuebase.md)

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(name, { connection, autorun, ...opts }, Connection)](./bullmq.queuescheduler._constructor_.md) |  | Constructs a new instance of the <code>QueueScheduler</code> class |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [close()](./bullmq.queuescheduler.close.md) |  |  |
|  [emit(event, args)](./bullmq.queuescheduler.emit.md) |  |  |
|  [isRunning()](./bullmq.queuescheduler.isrunning.md) |  |  |
|  [off(eventName, listener)](./bullmq.queuescheduler.off.md) |  |  |
|  [on(event, listener)](./bullmq.queuescheduler.on.md) |  |  |
|  [once(event, listener)](./bullmq.queuescheduler.once.md) |  |  |
|  [run()](./bullmq.queuescheduler.run.md) |  |  |

